
import {createStore} from 'vuex'
import {login,logout} from "@/store/fetchData.js";
import CryptoJS from "crypto-js";
import router from '@/router';

const store = createStore({
    state(){
        return{
            user:{},
            columns:[
                // store 에 저장 : 변하지 않을 값, 여러번 참조할
                "moduleName",
                "moduleType",
                "tableName",
                "tableMap",
                "insert",
                "update",
                "delete",
                "discard",
                "filtered"
            ]
        }
    },
    actions:{

        async getUser(store,{id,password}){
            const passwordHash=CryptoJS.SHA256(password).toString().toUpperCase()
            console.log(passwordHash)
            const loginData={
                id:id,
                password:passwordHash
            }
            const response = await login(loginData);
            console.log(response)

            if(response){
                this.commit("setUserData",response.data.data.user);
                console.log("스토어로 로그인에 성공");
                router.push('/Summery')
            }else{
                console.log("스토어로 로그인에 실패");
                router.push('/error')
            }

        },

        async clearUser(){
            const response = await logout();

            console.log(response)

            if(response.status === 200){
                this.commit("setUserData", {});
                console.log("로그아웃 성공");
                router.push('/login')
            }else{
                console.log("로그아웃 실패");
                router.push('/error')
            }
        }


    },

    // accessToken getters 에 담아서 꺼내쓰기
    // getters: {
    //   getAccessToken() {
    //       return this.state.user.info.accessToken
    //   }
    // },

    mutations:{
        setUserData(state,userData){
            state.user = userData
        },


    }
})
export default store;